#ifndef __THE_MAZE_OF_GALIOUS_2_ACTIVE_MAP
#define __THE_MAZE_OF_GALIOUS_2_ACTIVE_MAP


// ACTIVE GAME: 


class ActiveMAP {
	friend class ActiveMOG2;
	friend class ActiveOBJECT;
	friend class ActiveINTERFACE;

	friend class ActionSCRIPT;
	friend class ValueSCRIPT;

	friend class GameWindow;
	friend class GameDebugWindow;
	friend class NetworkGameWindow;

public:
	ActiveMAP(MAP *map,ActiveMOG2 *game);
	~ActiveMAP(void);

	bool save(FILE *fp);
	bool load(FILE *fp);

	bool cycle(class KEYBOARDSTATE **LVK,int n_LVKs);
//	void draw(SDL_Surface *sfc);

	ActiveOBJECT *find_object(int ID);
	bool find_object(ActiveOBJECT *o);

	int object_collision(ActiveOBJECT *o,bool hierarchical);
	int object_collision(ActiveOBJECT *o,int ax,int ay,bool hierarchical);
	ActiveOBJECT *object_collision2(ActiveOBJECT *o,int ax,int ay,int constitution,ConditionSCRIPT *s,ActiveOBJECT **foreign_object,bool hierarchical);
	void find_rooms_for_object(int x,int y,int dx,int dy,List<ROOM> *l);

	void remove_object_references(ActiveOBJECT *o);

	int get_variable_value(char *vname,int *ival,char **sval,ActiveOBJECT **oval);
	void set_variable_value(char *vname,int value);
	void set_variable_value(char *vname,char *value);
	void set_variable_value(char *vname,ActiveOBJECT *value);

private:

	void init_map(MAP *m);

	ActiveROOM *add_room(ROOM *r);

	List<VARIABLE> map_variables;
	List<ActiveROOM> active_rooms,inactive_rooms;
	MAP *map;

	/* Lists of new rooms to be added: */ 
	List<ActiveOBJECT> nrooms_object;
	List<List<ROOM> > nrooms_to_add;

	ActiveMOG2 *game;

	class ActionSCRIPT *map_action;
	bool focusingobject_in_room_edge;
};


#endif

