#include "string.h"

#include "SDL.h"
#include "SDL_ttf.h"
#include "BList.h"
#include "auxiliar.h"

#include "mog2.h"

#include "valuescript.h"
#include "conditionscript.h"
#include "actionscript.h"

#include "BWindow.h"
#include "BActiveWindow.h"
#include "BIntegerEdDlg.h"
#include "BStringEdDlg.h"
#include "BKeySelectionDlg.h"
#include "BChoiceDlg.h"
#include "BVChoiceDlg.h"
#include "TileViewWnd.h"
#include "TileSelectionWnd.h"
#include "ValueScriptWnd.h"
#include "OVariableWnd.h"
#include "OVariableEditorWnd.h"
#include "interfaces.h"

#include "editor.h"

extern int SCREEN_X,SCREEN_Y;

BViewValueScriptWnd::BViewValueScriptWnd(int x,int y,int dx,int dy,ValueSCRIPT *s,OBJECT *o,ROOM *r,MAP *m,MOG2 *g,MOG2_INTERFACE *interfp,EDITOR *e,int l,TTF_Font *font) : BWindow(x,y,dx,dy,font)
{
	editor=e;
	script=s;
	object=o;
	room=r;
	map=m;
	game=g;
	level=l;
	interf=interfp;
} /* BViewValueScriptWnd::BViewValueScriptWnd */ 


BViewValueScriptWnd::~BViewValueScriptWnd()
{
} /* BViewValueScriptWnd::~BViewValueScriptWnd */ 


bool BViewValueScriptWnd::cycle(int stx,int sty)
{
	BWindow::cycle(stx,sty);

	if (local_mouse_x>old_stx &&
		local_mouse_y>old_sty &&
		local_mouse_x<old_endx &&
		local_mouse_y<old_endy &&
		mouse_button&SDL_BUTTON(1) &&
		!(old_mouse_button&SDL_BUTTON(1))) {
		click_on_script(script,stx,sty);
		script->simplify();
		recompute_sizes(script);
		dirty=true;
	} /* if */ 


	if (local_mouse_x>old_stx &&
		local_mouse_y>old_sty &&
		local_mouse_x<old_endx &&
		local_mouse_y<old_endy &&
		mouse_button&SDL_BUTTON(3) &&
		!(old_mouse_button&SDL_BUTTON(3))) {
		right_click_on_script(script,stx,sty);
		script->simplify();
		recompute_sizes(script);
		dirty=true;
	} /* if */ 


	return true;
} /* BViewValueScriptWnd::cycle */ 


void BViewValueScriptWnd::contens_size(int *dx,int *dy)
{
	int max_x=0;
	int max_y=0;

	script_size(script,&max_x,&max_y);

	*dx=old_dx;
	*dy=old_dy;

	if (max_x+8>*dx) *dx=max_x+8;
	if (max_y+8>*dy) *dy=max_y+8;

} /* BViewValueScriptWnd::contens_size */ 


void BViewValueScriptWnd::draw_contens(SDL_Surface *sfc,int stx,int sty,int dx,int dy)
{

	SDL_FillRect(sfc,0,0);

	draw_script(sfc,script,4-stx,4-sty);

} /* BViewValueScriptWnd::draw_contens */ 


void BViewValueScriptWnd::draw_script(SDL_Surface *sfc,ValueSCRIPT *script,int stx,int sty)
{
	// ...
} /* BViewValueScriptWnd::draw_script */ 


bool BViewValueScriptWnd::click_on_script(ValueSCRIPT *script, int stx, int sty)
{
	// ...

	return false;
} /* BViewValueScriptWnd::click_on_script */ 


bool BViewValueScriptWnd::right_click_on_script(ValueSCRIPT *script, int stx, int sty)
{
	// ...

	return false;
} /* BViewValueScriptWnd::right_click_on_script */ 


void BViewValueScriptWnd::script_size(ValueSCRIPT *script,int *dx,int *dy)
{
	*dx = 4;
	*dy = 4;

	// ...

} /* BViewValueScriptWnd::condition_script_size */ 


void BViewValueScriptWnd::recompute_sizes(ValueSCRIPT *script)
{
	int i;

	for(i=0;i<6;i++) {
		if (script->vpar[i]!=0) {
			recompute_sizes(script->vpar[i]);
		} /* if */ 
	} /* for */ 

	script->dx=0;
	script->dy=0;
} /* BViewConditionScriptWnd::recompute_sizes */ 
